Function CreateCategory() : Set CreateCategory = new Category : End Function
Class Category
	Public ID
	Public IDString
	Public SmallImageUrl
	Public LargeImageUrl
	Public Name
	Public Description
	Public GameCount

	Private Sub Class_Initialize() : Clear : End Sub

	Private Sub Clear()
		ID=0
		SmallImageUrl=Application("SiteRoot") & "i/spacer.gif"
		LargeImageUrl=Application("SiteRoot") & "i/spacer.gif"
		Name = "None"
		Description = "Invalid Category ID"
		GameCount = 0
	End Sub

	Private Function SetProperties(a,b,c,d,e,f,g)
		ID = a
		IDString = b
		SmallImageUrl = c
		LargeImageUrl = d
		Name = e
		Description = f
		GameCount = g
	End Function

	Public Function Load(CategoryID)
		Load = True
		Clear()
		If IsNull(CategoryID) Then Exit Function
		
		Select Case CStr(CategoryID)
'GENERATED USING:
' DECLARE @imgRoot VARCHAR(MAX) SET @imgRoot = 'Application("SiteRoot") & "App_Themes\" & Session("Theme") & ' SELECT 'Case "' + CAST([Category_Num] AS VARCHAR(MAX)) + '","' + [Category_Id] + '" : ' + 'SetProperties ' + CAST([Category_Num] AS VARCHAR(MAX)) + ',' + '"' + [Category_Id] + '",' + @imgRoot + '"' + [Small_CategoryImage_Url] + '",' + @imgRoot + '"' + [Large_CategoryImage_Url] + '",' + '"' + [Category_Name] + '",' + '"' + [Category_Desc] + '",' + '0' FROM [ChooseYourStory]..[Categories] ORDER BY [Category_Num]
Case "1","Modern" : SetProperties 1,"Modern",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/modern.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/modern_full.gif","Modern","Suburban mall warfare and innercity strife",0
Case "2","Fantasy" : SetProperties 2,"Fantasy",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/fantasy.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/fantasy_full.gif","Fantasy","Come join the party and slay a dragon",0
Case "3","Sci_Fi" : SetProperties 3,"Sci_Fi",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/science_fiction.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/science_fiction_full.gif","Sci-Fi","Set the time machine to ""future"" and press go",0
Case "5","Mystery_Thriller" : SetProperties 5,"Mystery_Thriller",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/mystery_thriller.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/mystery_thriller_full.gif","Mystery / Thriller","Get a clue, Sherlock",0
Case "6","Family_Friendly" : SetProperties 6,"Family_Friendly",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/family_friendly.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/family_friendly_full.gif","Family Friendly", "Wholesomeness and group hugs for all",0
Case "7","Edutainment" : SetProperties 7,"Edutainment",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/edutainment.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/edutainment_full.gif","Edutainment","Learning was never this fun",0
Case "8","Love_Dating" : SetProperties 8,"Love_Dating",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/love_dating.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/love_dating_full.gif","Love & Dating","First comes love, then comes marriage...",0
Case "9","Fan_Fiction" : SetProperties 9,"Fan_Fiction",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/fan_fiction.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/fan_fiction_full.gif","Fan Fiction","When you just can't get enough",0
Case "10","Horror" : SetProperties 10,"Horror",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/horror.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/horror_full.gif","Horror","Zombies, mummies, and monsters, oh my!",0
Case "11","Grimdark_Fantasy" : SetProperties 11,"Grimdark_Fantasy",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/grimdark_fantasy.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/grimdark_full.gif","Grimdark Fantasy","When darkness calls, you must answer",0
Case "12","Puzzle_Games" : SetProperties 12,"Puzzle_Games",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/puzzle_games.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/puzzle_games_full.gif","Puzzle / Games","Putting the game in storygame",0
Case "13","Historical" : SetProperties 13,"Historical",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/historical.gif",Application("SiteRoot") & "App_Themes\" & Session("Theme") & "categories/historical_full.gif","Historical", "Have a blast in the past",0
Case Else : Load = False
		End Select
	End Function
End Class

Function WriteCategoryOptions(selected)
	Dim Cats : Cats = LoadAllCategories(false)
	Dim i : For i = 0 To UBound(Cats)
		Response.Write "<option value=""" & Cats(i).ID & """"
		If Cats(i).ID = selected Then Response.Write " selected=""true"""
		Response.Write ">" & Cats(i).Name & "</option>"
	Next
End Function

Function LoadAllCategories(CountGames)

    'DECLARE @c VARCHAR(MAX) SET @c='' SELECT @c = @c + CAST(Display_Seq AS VARCHAR(MAX)) + ',' FROM [ChooseYourStory]..[Categories] ORDER BY [Category_Num] SELECT '(' + LEFT(@c,LEN(@c)-1) + ')'
	Dim Order : Order = Array(2,11,3,1,10,8,5,6,13,12,7,9) 'This is the order that storygame categories appear in on the storygames page.

	Dim Categories
	ReDim Categories(UBound(Order))
	Dim i : For i = 0 To UBound(Categories)
		Set Categories(i) = New Category
		Categories(i).Load Order(i)
	Next

	If CountGames Then 
		Dim Conn : Set Conn = Server.CreateObject("ADODB.Connection")
		Conn.Open Application("ConnectionString")

		Dim Rst
		Set Rst = Conn.Execute("SELECT [Category ID],[Game Count] FROM [Game Count by Category]")
		While Not Rst.EOF
			For i = 0 To UBound(Categories)
				If Categories(i).ID = Rst(0) Then Categories(i).GameCount=Rst(1)
			Next
			Rst.MoveNext()
		Wend

		Rst.Close() 
		Conn.Close()
	End If

	LoadAllCategories = Categories

End Function

