<% Option Explicit %>
<!-- #include file="../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../Includes/userRoles.vbs"></script>
<script runat="server" language="vbscript" src="../Includes/logger.vbs"></script>
<script runat="server" language="vbscript" src="../Includes/CheckHeader.vbs"></script>
<script runat="server" language="jscript" src="../Includes/he.js"></script>
<%
CheckHeader "ProcessFeature.aspx"

If Not IsInRole("Forums Features Administrator") Then Response.Redirect "./"

Dim Target
	If IsEmpty(Request("target")) Then
		Target = "./"
	Else
		Target = Request("target")
	End If

Dim Action, ActionDescription
    Action = Request.QueryString("action")
	Select Case Action 
		Case "accept" : ActionDescription =  "Accept Feature Post"
		Case "reject" : ActionDescription =  "Reject Feature Post"
		Case "complete" : ActionDescription =  "Complete Feature Post"		
		Case Else
			Response.Write "Invalid Action: " & Action
			Response.End
	End Select

Dim MessageId : MessageId = CLng(Request("MessageId"))

'Process Database Update if posted
Dim DbAction
If Not IsEmpty(Request.Form("accept")) Then DbAction = "Accepted"
If Not IsEmpty(Request.Form("reject")) Then DbAction = "Rejected"
If Not IsEmpty(Request.Form("complete")) Then DbAction = "Completed"

If Not IsEmpty(DbAction) Then
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionString")
		.CommandType = adCmdStoredProc
		.CommandText = "Forums_Change_Feature_Status"
		.Parameters.Append .CreateParameter("@Message_Id", adInteger, adParamInput, 4, MessageId)
		.Parameters.Append .CreateParameter("@Status", adVarChar, adParamInput, 9, DbAction)		
		.Parameters.Append .CreateParameter("@Comments", adVarChar, adParamInput, 2000, escape(Request.Form("Comments")))
		.Parameters.Append .CreateParameter("@Accept_Points", adInteger, adParamInput, 4, Null)
		If Not IsEmpty(Request.Form("Points")) Then .Parameters("@Accept_Points").Value = Request.Form("Points")
		.Execute
	End With
	Response.Redirect Target	
End If


%>
<h1 style="padding-bottom:15px"><a href="./">Forums</a><span> &raquo; Administration</span></h1>

<h2 class="tableHead" style="padding:2px"><%=ActionDescription%></h2>
<%
Dim PostSubject
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Application("ConnectionString")
	.CommandText = _
		"SELECT * " & _
		"  FROM [Forums_Posts_Expanded] " & _
		" WHERE [Message_Id] = ? AND [Left] = 1" 
	.Parameters.Append .CreateParameter("Message_Id", adInteger, adParamInput, 4, MessageId)
	With .Execute
		If Not .EOF Then
		PostSubject = .Fields("Subject")
	%><div style="margin:10px;border:1px solid black">
		  <div class="back1Background">
			<table cellpadding="5" cellspacing="0" border="0"><tr>
			  <%If Not IsNull(.Fields("Avatar Image Id")) Then%><td align="left">
				<img style="float:left" height="45" width="45" src="/i/?<%=.Fields("Avatar Image Id")%>"/>
			  </td><%End If%>
			  <td valign="top">
				<h2><%=.Fields("Subject")%></h2>
				<span class="smallerText">
				  by <%=.Fields("Username")%> 
				  on <%=FormatDateTime(.Fields("Post_Date"),2)%>&nbsp;<%=FormatDateTime(.Fields("Post_Date"),4)%>&nbsp;EST
				</span>
			  </td>
			</tr></table>
		  </div>
		  <p style="margin:0px;padding:15px;"><%=.Fields("Body")%></p>
		</div><%
			End If
		End With
	End With
%>

<form method="post">
<div style="margin-top:10px;">

  <p style="padding:10px;font-size:10pt" class="error">
  <label>Comments</label><br/>
  <textarea rows="6" cols="60" name="Comments"></textarea>
  <br/><br/>

<% If Action="accept" Then %>
  <label>Points To Award</label>
  <input type="text" size="5" maxlength="5" name="Points" value="20">
<% End If %>
  	
  </p>

  <br/>
  <input type="submit" onClick="if (this.form.Comments.value=='') {alert('Comments are required');return false;}" name="<%=Action%>" value="<%=ActionDescription%>">
  &nbsp;
  <input type="button" onClick="location=this.form.elements.target.value;" value="Cancel">
  <input type="hidden" name="MessageId" value="<%=MessageId%>">
  <input type="hidden" name="target" value="<%=target%>">
  </div>
</form>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>
