using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using ChooseYourStory.Utilities;

namespace ChooseYourStory.Web.UI.WebParts
{

  public partial class MyStoriesWebPart : System.Web.UI.UserControl, IWebPart
  {
    public MyStoriesWebPart()
    {
      _Title = "My Storygames";
    }
    protected override void CreateChildControls()
    {
      //<%@ Register TagPrefix="cys" TagName="MyStories" Src="~/My/MyStories.ascx" %>
      //<cys:MyStories runat="server" Width="100%" ShowHeader="true" />base.CreateChildControls();
      base.CreateChildControls();
      Controls.Add(LoadControl("~/My/MyStories.ascx"));
      
    }

    #region IWebPart Members

    public string CatalogIconImageUrl
    {
      get { return string.Empty; }
      set { throw new NotImplementedException(); }
    }

    public string Description
    {
      get { return "Displays a listing of all of your published and unpublished Storygames."; }
      set { throw new NotImplementedException(); }
    }

    public string Subtitle
    {
      get { return string.Empty; }
    }

    private string _Title;
    public string Title
    {
      get { return _Title; }
      set { _Title = value; }
    }

    public string TitleIconImageUrl
    {
      get { return string.Empty; }
      set { throw new NotImplementedException(); }
    }

    public string TitleUrl
    {
      get { return "games.aspx"; }
      set { throw new NotImplementedException(); }
    }

    #endregion
  }

}
