<%@ Page Language="C#" AutoEventWireup="true" Title="Advanced Editor" %>
<%@ Register TagPrefix="cys" 
    Namespace="ChooseYourStory.Web.Controls"
    Assembly="ChooseYourStory" %>
<asp:Content ContentPlaceHolderID="HeaderContentPlaceHolder" runat="server">
<script src="common.js"></script>
<script>

function deleteVariable(varName)
{
	if (!(confirm(
			'You are about to delete a variable. Any text boxes containing\n'
			+ 'the variable (e.g., %%'+varName+'%%) will not be deleted, causing a 0 to be displayed.\n\n'
			+ 'Are you absolutely sure you want to delete this variable?\n'
			+ 'There is no way of undoing this.\n'))) return false;
	
	PostBack('deletevariable',varName);	
}

function createVariable()
{
	var varName = '';
	while (true)
	{
		varName = prompt('Enter a name for a new variable.',varName);
		if (varName==null) return;
		varName = varName.toUpperCase();
		if (checkFormat(varName)) break;
	}
	
	PostBack('newvariable',varName);	
}	

function checkFormat(varName)
{
	if (/^[A-Z][A-Z0-9]{0,9}$/.exec(varName))
	{
		return true
	}
	else
	{		
		alert('The name of the variable you entered was not valid. Variables must \n'
				+ ' - have 1-10 characters\n'
				+ ' - be in ALL CAPS\n'
				+ ' - contain letters (A-Z) and numbers (0-9) only\n'
				+ ' - have a letter as the first character');
		return false;
	}
}
</script>
</asp:Content>    
<asp:Content ContentPlaceHolderID="MainContentPlaceHolder" Runat="Server">
    <cys:AspPage runat="server" Url="variables.asp" CopyQueryString="true" CopyForm="true" />
</asp:Content>