<% option explicit %>
<!-- #include file="../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../Includes/logger.vbs"></script>
<script runat="server" language="vbscript" src="../Includes/helperFunctions.vbs"></script>
<script runat="server" language="vbscript" src="../Includes/userRoles.vbs"></script><%

If Not IsInRole("Site Administrator") Then  Response.Redirect Application("SiteRoot")

Dim GameID : GameID = Request("GameId")

If Len(Request.Form("cancel")) Then
	Response.Redirect "gamePopUp.asp?" & GameId
		
ElseIf Len(Request.Form("feature"))>0 Then
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionString")
		.CommandType = adCmdStoredProc
		.CommandText = "[Feature Game]"
		.Parameters.Append .CreateParameter("Game Id", adInteger, adParamInput, 4, GameID)
		.Parameters.Append .CreateParameter("Notes", adVarChar, adParamInput, 255, Request.Form("Notes"))
		.Execute
	End With
	With New Logger : .AdminGame(GameID) : End With
	Response.Redirect "gamePopUp.asp?" & GameId

ElseIf Len(Request.Form("unfeature"))>0 Then
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionString")
		.CommandType = adCmdStoredProc
		.CommandText = "[Unfeature Game]"
		.Parameters.Append .CreateParameter("Game Id", adInteger, adParamInput, 4, GameID)
		.Execute
	End With
	With New Logger : .AdminGame(GameID) : End With
	Response.Redirect "gamePopUp.asp?" & GameId	
End If


Dim Title, DateCategoryFeatured
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Application("ConnectionString")
	.CommandText = _
		"SELECT [Title], [Date Category Featured] " & _
		"  FROM [Games] " & _
		" WHERE [Game Id] = ?"
	.Parameters.Append .CreateParameter("Game Id", adInteger, adParamInput, 4, GameID)
	With .Execute
		If .EOF Then : Response.Write "Invalid GameId" : Response.End : End If
		Title = .Fields("Title")
		DateCategoryFeatured = .Fields("Date Category Featured")
	End With
End With
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Feature Game</title>
<link href="../App_Themes/CYS/styles.css" rel="stylesheet" type="text/css" />
</head>
<body style="margin:5px; ">
<form method="post">

<% If IsNull(DateCategoryFeatured) Then %>
  <h1>Feature Game</h1>
<% Else %>
  <h1>Unfeature Game</h1>
<% End If %>

<h2 style="margin-top:10px;">Game Title</h2><%=Title%>

<% If IsNull(DateCategoryFeatured) Then %>
	<h2 style="margin-top:10px;">Note to Author (optional)</h2>
	<input type="text" maxlength="200" size="65" name="Notes"/>
<% Else %>
	<h2 style="margin-top:10px;">Date Featured</h2>
	<%=FormatDateTime(DateCategoryFeatured,2)%>
<% End If %>

<p style="margin-top:10px;">
<% If IsNull(DateCategoryFeatured) Then %>
	<input name="feature" type="submit" value="Feature Game" onClick="return (confirm('Are you sure you want to feature?'))" />
<% Else %>
	<input name="unfeature" type="submit" value="Unfeature Game" onClick="return (confirm('Are you sure you want to unfeature?'))" />
<% End If %>	
	&nbsp;
    <input name="cancel" type="submit" value="Cancel"/></td>
</p>
</form>
</body>
</html>