<!-- #include file="../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../Includes/logger.vbs"></script>
<script runat="server" language="vbscript" src="../Includes/CheckHeader.vbs"></script>
<% 
CheckHeader "../Help/History.aspx"

Dim log : Set log = New Logger : log.ReadHistory()%>


<style>p{margin-top:15px;}</style>
<div id="mainContent">
            <h1>Info &raquo; History of Choose-Your-Own-Adventures</h1>
            <p><img src="../images_old/charlemagne.jpg" width="175" height="185" style="float:right; ">The 
              Choose-Your-Own-Adventure game that we all know and love has had 
              a relatively short history dating back to the eighth century. It 
              all began in the Carolingian Empire with a fellow by the name of 
              Tydestro the Storyteller. Tydestro was a loyal member of Charlemagne's 
              troops and led a rather typical life battling the Saxons and taking 
              over Europe. In his free time, Tydestro would write stories about 
              the long wars and describe various possible endings. He amassed 
              an impressive collection of thirteen books with over four hundred 
              different outcomes!</p>
            <p>In 778, Charlemagne was passing through the Pyrenees Mountains 
              to conquer Spain, and decided to rest at the camp that Tydestro 
              was currently staying. An intended two hour rest soon turned into 
              long, three-day stay as Tydestro amused Charlemagne with his ever-changing 
              tales of empire victories. Charlemagne fell in love with the Choose-Your-Own-Adventure 
              stories and hired Tydestro as his personal storywriter and entertainer.</p>
            <p>From then on, Choose-Your-Own-Adventure stories and games became 
              very popular throughout Charlemagne's empire. However, only royalty 
              and noblemen enjoyed these tales. There is no evidence that these 
              stories were played by the lower class, and many provinces even 
              barred the common people from possessing one of these works.</p>
            <p><img src="../images_old/fortune.jpg" width="108" height="109" style=" float:left ">Choose-Your-Own-Adventure 
              stories remained in the hands of the wealthy Europeans until 1271. 
              It was at this time that Marco Polo introduced one of these popular 
              tales to the Chinese, who quickly came to adore these. In China, 
              throughout the Mongul Dynasty, Choose-Your-Own-Adventure stories 
              took on a completely new form. Using the art of Oragami, the Chinese 
              Folding Fortune Teller was created by drawing possible outcomes 
              on a square piece of paper. These fortune tellers are source of 
              much fun and debate.</p>
            <p>Many Chinese Nationalists contend that Choose-Your-Own-Adventure 
              games originated in China with the folding fortune tellers. This 
              is noted to be one of the many heated issues during the Boxer Rebellion. 
              Mao Stung noted that &quot;it is, however, the West who write the 
              history books.&quot; This attitude is consistent with quite a few 
              Eastern historians. </p>
            <p>Some historians doubt a Charlemagne or Chinese origin. Heinrich 
              Shlieman argues that Choose-Your-Own-Adventure Games were a sport 
              in the ancient city of Troy and originated in prehistoric times. 
              However, the only archeological evidence found to date are a series 
              of Ad Libs in the ruins of Troy and a cave painting of a single 
              Tic Tac Toe board believed to end in a violent cat's game. </p>
            <p>The Choose-Your-Own-Adventure story telling and gaming remained 
              relatively quiet from the 14th to 18th century. While there was 
              a small boom tied to the Renaissance movement in the 1620's, little 
              to no development was seen during this time. </p>
            <p><img src="../images_old/benit.jpg" width="150" height="203" style=" float:right ">1884 
              is seen by many scholars as the Great Revival of the Choose-Your-Own-Adventure 
              style. It was in this year that Alfred Binet, the Commissioner of 
              Education in France, devised a system of learning by incorporating 
              Choose-Your-Own-Adventure stories and games. This system was tested 
              in three schools and it was discovered that students could learn 
              more with less teacher involvement while having more fun than traditional 
              learning. However, teachers vehemently opposed the idea and the 
              system never was implemented.</p>
            <p>Many of the students in these schools, however, went on to write 
              their own Choose-Your-Own-Adventure tales. The concept again spread 
              like wild fire throughout Europe and was eventually brought to America. 
              Robert Frost was known to be a coinsurer of these tales and often 
              made references to them in his poems. Perhaps his most famous reference 
              is seen in his 1915 poem, The Road Not Taken: &quot;I shall be telling 
              this with a sigh / Somewhere ages and ages hence: / Two roads diverged 
              in a wood, and I-- / I took the one less traveled by, / And that 
              has made all the difference.&quot;</p>
            <p><img src="../images_old/robinson.jpg" width="135" height="189" style="float:left ">Unfortunately, 
              with the great depression, two world wars, a communist scare, and 
              the Korean and Vietnam wars many Americans minds were not focused 
              on stories and games, and the Choose-Your-Own-Adventure concept 
              was nearly lost once again. It wasn't until 1973 that Stanford history 
              professor Paul Robinson, while researching medieval operas, incidentally 
              came across the old concept again. The rediscovered Choose-Your-Own-Adventure 
              stories quickly spread throughout the higher levels of academia. 
            </p>
            <p>It seemed to finally reach the popular culture in the 1980's where 
              it exploded with a bang. By 1984, over <a href="http://www.gamebooks.org" target="_blank">3000 books</a> were written and 
              even Choose-Your-Own-Adventure movies were produced. Unfortunately, 
              the renewed movement was quickly crushed by concerned parents and 
              various church leaders. These books and movies were deemed outright 
              Satanic and many libraries and book stores refused to carry them. 
              As one high-ranking member of the Christian Coalition put it, &quot;stories 
              aren't meant to have multiple endings; there's no such thing a Choose-Your-Own-Adventure 
              Bible.&quot;</p>
            <p>Once again, the precious art of Choose-Your-Own-Adventure was stripped 
              away from the common man. Sales plummeted, books were burned, and 
              blossoming Authors, who may have become the next Shakespeare, were 
              out of a job. Many dedicated fans thought Choose-Your-Own-Adventures 
              would be gone forever.</p>
            <p>Now, in the year 2002, the art is reborn again as MyAdventureGame.com 
              brings Choose-Your-Own-Adventure games to the masses. No longer 
              are Choose-Your-Own-Adventures exclusively for royalty or restricted 
              to the upper class. And now, for the first time in history, any 
              one can play - or even create - a Choose-Your-Own-Adventure game. 
            </p>
</div>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>
