Sub Navigate(Place,GameID)
	Select Case Place
		Case "properties" : Response.Redirect("properties.aspx?" & GameID)
		Case "items"  : Response.Redirect("items.aspx?" & GameID)
		case "scripts" : Response.Redirect("scripts.aspx?" & GameID)
		Case "variables"  : Response.Redirect("variables.aspx?" & GameID)		
		Case "chapters"   : Response.Redirect("chapters.aspx?" & GameID)		
		Case "preview"   : Response.Write("<script type='text/javascript'>window.open('/story/viewer/default.aspx?StoryId=" & GameID & "', 'preview', 'height=600,width=737,directories=no,location=no,resizable=yes,menubar=no,toolbar=no,scrollbars=yes');</script>")
		Case "exit"      : Response.Redirect("../")
	End Select
End Sub

Sub WriteSecondaryNavigation
	const TITLE = 0
	const URL = 1
	const IS_SELECTED = 2
	
	Dim dispVariables, dispScripting
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionSTring")
		.CommandText = "ChooseYourStory.dbo.Story_Editing_GetEditorOptions"
		.CommandType = adCmdStoredProc
		.Parameters.Append .CreateParameter("@StoryId",adInteger,adParamInput,4,GameId)
		.Parameters.Append .CreateParameter("@User_Username",adVarChar,adParamInput,20,Session("Username"))
		With .Execute
			dispVariables = .Fields("Variable_Level") <> "Disabled"
			dispScripting = .Fields("Scripting_Level") <> "Disabled"
		End With
	End With
	
	Dim Links : Links = Array _
		( _
			Array(Session("StoryProper") & " Properties","JavaScript: PostBack('nav','properties')",False), _
			Array("Items","JavaScript: PostBack('nav','items')",False), _
			Array("Variables","JavaScript: PostBack('nav','variables')",False), _			
			Array("Scripts","JavaScript: PostBack('nav','scripts')",False), _			
			Array("Chapters & Pages","JavaScript: PostBack('nav','chapters')",False), _
			Array("Preview","JavaScript: PostBack('nav','preview')",False), _
			Array("Save & Exit","JavaScript: PostBack('nav','exit')",False) _		
		)				
	Dim Script : Script = LCase(Request.ServerVariables("SCRIPT_NAME"))
	Script = Right(Script,Len(Script)-InStrRev(Script,"/"))
	
	Select Case Script
		Case "properties.asp","default.asp" : Links(0)(IS_SELECTED) = True
		Case "items.asp" : Links(1)(IS_SELECTED) = True
		Case "variables.asp" : Links(2)(IS_SELECTED) = True				
		Case "chapters.asp" : Links(4)(IS_SELECTED) = True		
	End Select
		
	Dim i : For i = 0 To UBound(Links)
		If Links(i)(TITLE) = "Variables" And Not dispVariables Then
			'Do Nothing
		ElseIf Links(i)(TITLE) = "Scripts" And Not dispScripting Then
			'Do Nothing
		Else
			If Links(i)(IS_SELECTED) Then
				Response.Write "<a href=""" & Links(i)(URL) & """ style=""font-weight:bold;"">"
				Response.Write Links(i)(TITLE)
				Response.Write "</a>"
			Else
				Response.Write "<a href=""" & Links(i)(URL) & """ >"
				Response.Write Links(i)(TITLE)
				Response.Write "</a>"
			End If
			If i <> UBound(Links) Then Response.Write " / "
		End If
	Next
End Sub